package sorts;

import util.OArrays;

/**
 * Sort.java
 * Created by Stijn Strickx on May 21, 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */

/**
 * The datatype conversions for the arrays won't influence 
 * the time complexity of the sorting algorithms.
 * Without these conversions,
 * the algorithms would have to be re-written for every primitive datatype.
 */

public class Sort {
    
    public static <T extends Comparable<? super T>> void bubbleSort(T[] a){
        (new BubbleSort()).sort(a);
    }
    public static int[] bubbleSort(int[] a){
        Integer[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static long[] bubbleSort(long[] a){
        Long[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static double[] bubbleSort(double[] a){
        Double[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static float[] bubbleSort(float[] a){
        Float[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static char[] bubbleSort(char[] a){
        Character[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static boolean[] bubbleSort(boolean[] a){
        Boolean[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static byte[] bubbleSort(byte[] a){
        Byte[] b = OArrays.toObjectArray(a);
        bubbleSort(b);
        return OArrays.toPrimitiveArray(b);
    }
}